/* Process model C form file: cRTP.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char cRTP_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 40902861 40902861 1 kelvin kkoa 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                            ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include <ip_addr_v4.h>
#include <ip_dgram_sup.h>
#include <udp_dgram_sup.h>

/* Define debug verbosity. */
#define VERBOSE_0				1
#define VERBOSE_1				0
#define VERBOSE_X				0
#define VERBOSE_XX				0
#define VERBOSE_XXX				0
#define VERBOSE_ERR				1

/* Define boolean for finding existing session context. */
#define NOT_FOUND				0
#define	FOUND					1

/* Packet stream definitions. */
#define	UNCOMP_IN_STRM			0
#define COMP_IN_STRM			1
#define	UNCOMP_OUT_STRM			0
#define COMP_OUT_STRM			1
/*#define RTP_PAYLOAD_SIZE		40*/

/* CID length. Temporary solution to handle only 16-bit CIDs.
   This will be changed to a variable in the future which may
   be toggled on and off. */
#define	CID8					1
#define	CID16					0
#define MAX_NUM_CID8		  256
#define MAX_NUM_CID16		25536

/* MSTI setting to see whether the CSRC Count and List had changed.
   We are not using this now, but this is here for easy future
   enhancement. */
#define	csrcCountAndList		0
#define new_csrc_count			0

/* Define state transition arguments. */
#define UNCOMP_PKT_ARRVL   		((op_intrpt_type () == OPC_INTRPT_STRM) && (op_intrpt_strm() == UNCOMP_IN_STRM))
#define COMP_PKT_ARRVL			((op_intrpt_type () == OPC_INTRPT_STRM) && (op_intrpt_strm() == COMP_IN_STRM))

/* Define maximum times a CONTEXT_STATE packet should be sent. */
#define CONTEXT_STATE_MAX_RETRY	10

typedef struct
	{
	/* IP header fields. */
	int					ip_version;
	int					ip_ihl;
	int					ip_tos;
    int                 ip_length;
    int                 ip_ident;
	int					ip_flags;
    int                 ip_frag_offset;
    int                 ip_ttl;
	int					ip_protocol;
	int					ip_header_checksum;
    unsigned long       ip_src_addr;
    unsigned long       ip_dest_addr;

	/* UDP header fields. */
    int         		udp_src_port;
    int         		udp_dest_port;
    int         		udp_length;
    int         		udp_checksum;

	/* RTP header fields. */
	int					rtp_version;
	int					rtp_padding;
	int					rtp_extension;
	int					rtp_csrc_count;
	int					rtp_marker;
	int					rtp_payload_type;
	int					rtp_seq_number;
	int					rtp_timestamp;
	int					rtp_ssrc;
	} RTP_UDP_IP_HEADER;

typedef struct
	{
	int					delta_ip_id;		/* 1st order IPv4 ID difference. */
	int					delta_rtp_ts;		/* 1st order RTP timestamp difference. */
	int					delta_rtp_seq;		/* last value of 4 bit sequence number. */
	} FIELD_DELTAS;

typedef struct
	{
	RTP_UDP_IP_HEADER	headerInfo;			/* RTP/UDP/IP header fields for this stream. */
	FIELD_DELTAS		fieldDeltas;		/* Deltas for this stream. */
	int					context_id;			/* session context id. */
	int					link_seq;			/* link sequence for the session context. */
	int					last_packet;		/* last RTP packet stream indicator. */
	int					invalid;			/* context state invalid due to dropped packet */
	int					sendFullNext;		/* flag to send FullPacket next */
	} CONTEXT_STATE_INFO;

typedef struct
	{
	int					mFlag;				/* flag for m bit. */
	int					tFlag;				/* flag for t bit. */
	int					sFlag;				/* flag for s bit. */
	int					iFlag;				/* flag for i bit. */
	} MSTI_FIELDS;

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	List*	                  		contextStateXmtList;
	List*	                  		contextStateRcvList;
	int	                    		errorCountComp;
	int	                    		errorCountDecomp;
	int	                    		totalDroppedPackets;
	Ici*	                   		comp_ici_ptr;
	Stathandle	             		rcvd_comp_packet_handle;
	Stathandle	             		rcvd_comp_byte_handle;
	Stathandle	             		rcvd_decomp_packet_handle;
	Stathandle	             		rcvd_decomp_byte_handle;
	Stathandle	             		sent_comp_packet_handle;
	Stathandle	             		sent_comp_byte_handle;
	Stathandle	             		sent_decomp_packet_handle;
	Stathandle	             		sent_decomp_byte_handle;
	int	                    		compContextStateUpdating;
	int	                    		decompContextStateUpdating;
	char	                   		recv_fmt_name[20];
	char	                   		fmt_name[20];
	Ici*	                   		decomp_ici_ptr;
	Stathandle	             		num_dropped_packets;
	Objid	                  		own_objid;
	Stathandle	             		packet_dropped_handle;
	Stathandle	             		sent_context_state_handle;
	Stathandle	             		rcvd_context_state_handle;
	} cRTP_state;

#define pr_state_ptr            		((cRTP_state*) SimI_Mod_State_Ptr)
#define contextStateXmtList     		pr_state_ptr->contextStateXmtList
#define contextStateRcvList     		pr_state_ptr->contextStateRcvList
#define errorCountComp          		pr_state_ptr->errorCountComp
#define errorCountDecomp        		pr_state_ptr->errorCountDecomp
#define totalDroppedPackets     		pr_state_ptr->totalDroppedPackets
#define comp_ici_ptr            		pr_state_ptr->comp_ici_ptr
#define rcvd_comp_packet_handle 		pr_state_ptr->rcvd_comp_packet_handle
#define rcvd_comp_byte_handle   		pr_state_ptr->rcvd_comp_byte_handle
#define rcvd_decomp_packet_handle		pr_state_ptr->rcvd_decomp_packet_handle
#define rcvd_decomp_byte_handle 		pr_state_ptr->rcvd_decomp_byte_handle
#define sent_comp_packet_handle 		pr_state_ptr->sent_comp_packet_handle
#define sent_comp_byte_handle   		pr_state_ptr->sent_comp_byte_handle
#define sent_decomp_packet_handle		pr_state_ptr->sent_decomp_packet_handle
#define sent_decomp_byte_handle 		pr_state_ptr->sent_decomp_byte_handle
#define compContextStateUpdating		pr_state_ptr->compContextStateUpdating
#define decompContextStateUpdating		pr_state_ptr->decompContextStateUpdating
#define recv_fmt_name           		pr_state_ptr->recv_fmt_name
#define fmt_name                		pr_state_ptr->fmt_name
#define decomp_ici_ptr          		pr_state_ptr->decomp_ici_ptr
#define num_dropped_packets     		pr_state_ptr->num_dropped_packets
#define own_objid               		pr_state_ptr->own_objid
#define packet_dropped_handle   		pr_state_ptr->packet_dropped_handle
#define sent_context_state_handle		pr_state_ptr->sent_context_state_handle
#define rcvd_context_state_handle		pr_state_ptr->rcvd_context_state_handle

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	cRTP_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cRTP (void);
	Compcode cRTP_init (void **);
	void cRTP_diag (void);
	void cRTP_terminate (void);
	void cRTP_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cRTP (void)
	{
	int _block_origin = 0;
	FIN (cRTP ());
	if (1)
		{
		char				proc_model_name[20];
		Objid				own_node_objid;
		Prohandle			own_prohandle;
		
		int					intrpt_type;
		int					intrpt_strm;
		
		int					pk_size;			/* Size of a packet (bits). */
		int					byte_load;			/* Size of a packet (bytes). */
		int					udpLength;			/* Temp variable for UDP Length. */
		int					ipLength;			/* Temp variable for IP Length. */
		
		IpT_Dgram_Fields*	ipHeaderPtr;		/* Temp IP header for extracting information. */
		UdpT_Dgram_Fields*	udpHeaderPtr;		/* Temp UDP header for extracting information. */
		
		Packet*				ip_pkptr;			/* Pointer to IP packet. */
		Packet*				udp_pkptr;			/* Pointer to UDP packet. */
		Packet*				rtp_pkptr;			/* Pointer to RTP packet. */
		Packet*				data_pkptr;			/* Pointer to generic packet. */
		Packet*				orig_pkptr;			/* Pointer to original packet pointer. */
		Packet*				payload_pkptr;		/* Pointer to generic payload data. */
		
		RTP_UDP_IP_HEADER	newPktFields;		/* Temporary RTP/UDP/IP header used for comparison. */
		
		CONTEXT_STATE_INFO* tempContextStatePtr;
		CONTEXT_STATE_INFO* retContextStatePtr;
		int					xmtListSize;		/* Size of transmission context state list. */
		int					rcvListSize;		/* Size of transmission context state list. */
		
		int					found;				/* Indicator of whether session context was found. */
		int					foundIndex;			/* Index in list item was found. */
		int					i;					/* Generic index. */
		
		int					canCompRTP;			/* Flag for RTP compression (compressor). */
		int					canCompUDPIP;		/* Flag for UDP compression (compressor). */
		
		MSTI_FIELDS			tempMSTIfields;		/* Temp storage for MSTI fields from compressed RTP packet. */
		
		/* DON'T NEED THESE GUYS HERE. */
		int					origUDPlength;		/* Taken from the ICI passed along with the packet. */
		int					origIPlength;		/* Taken from the ICI passed along with the packet. */
		
		int					rcvd_context_id;	/* The context id received in an FULL_HEADER packet. */
		int					rcvd_context_id_lsb;	/* LSB for CID16 */
		int					rcvd_context_id_msb;	/* LSB for CID16 */
		
		int					rcvd_link_seq;		/* The link sequence received in a FULL_HEADER packet. */
		
		int					delta_rtp_ts;		/* New - previous timestamp (compressor) OR new delta (decompressor). */
		int					delta_rtp_seq;		/* New - previous sequence number (compressor) OR new delta (decompressor). */
		int					delta_ip_id;		/* New - previous IPv4 ID (compressor) OR new delta (decompressor). */
		int					rtp_ts_changed;		/* Indicators of which deltas changed. */
		int					rtp_seq_changed;
		int					ip_id_changed;
		
		int					error;				/* Error flag. */
		int					droppedPacket;		/* Flag indicating decompressor detecting dropped packet. */
		int					pktFmtError;		/* Error flag toggled by a packet format error. */
		
		int					newCID;
		int					CIDavail;
		
		int					tempUdpLength;		/* Used by decompressor. */
		int					tempIpLength;


		FSM_ENTER (cRTP)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "cRTP [init enter execs]")
				FSM_PROFILE_SECTION_IN ("cRTP [init enter execs]", state0_enter_exec)
				{
				
				/* Obtain the neccessary objids.							*/
				own_objid = op_id_self ();
				own_node_objid = op_topo_parent (own_objid);
				
				/* Obtain the ip_encap process's prohandle.					*/
				own_prohandle = op_pro_self ();
				
				/* Obtain the name of the process. It is the				*/
				/* "process model" attribute of the module.					*/
				op_ima_obj_attr_get (own_objid, "process model", proc_model_name);
				
				/* Create and initialize lists to contain context state information of
				   incoming and outgoing streams. */
				
				contextStateXmtList = op_prg_list_create();
				op_prg_list_init (contextStateXmtList);
				
				contextStateRcvList = op_prg_list_create();
				op_prg_list_init (contextStateRcvList);
				
				errorCountComp = 0;
				
				/* Register stat handles */
				rcvd_comp_packet_handle		= op_stat_reg ("comp.Traffic Received (Packets)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				rcvd_comp_byte_handle		= op_stat_reg ("comp.Traffic Received (Bytes)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				sent_comp_packet_handle		= op_stat_reg ("comp.Traffic Sent (Packets)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				sent_comp_byte_handle		= op_stat_reg ("comp.Traffic Sent (Bytes)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				sent_context_state_handle   = op_stat_reg ("comp.Context State Packets Sent", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				rcvd_decomp_packet_handle	= op_stat_reg ("decomp.Traffic Received (Packets)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				rcvd_decomp_byte_handle		= op_stat_reg ("decomp.Traffic Received (Bytes)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				sent_decomp_packet_handle	= op_stat_reg ("decomp.Traffic Sent (Packets)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				sent_decomp_byte_handle		= op_stat_reg ("decomp.Traffic Sent (Bytes)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				packet_dropped_handle       = op_stat_reg ("decomp.Dropped Packets", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				rcvd_context_state_handle   = op_stat_reg ("decomp.Context State Packets Received", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				
				/* No context state lists are being updated (initialize). */
				compContextStateUpdating	= 0;
				decompContextStateUpdating  = 0;
				}

				FSM_PROFILE_SECTION_OUT ("cRTP [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "cRTP [init exit execs]")
				FSM_PROFILE_SECTION_IN ("cRTP [init exit execs]", state0_exit_exec)
				{
				printf ("Header Comp/Decomp %d: Initialized.\n", own_objid);
				}
				FSM_PROFILE_SECTION_OUT ("cRTP [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "wait")
				/*---------------------------------------------------------*/



			/** state (wait) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "wait", "cRTP [wait enter execs]")
				FSM_PROFILE_SECTION_IN ("cRTP [wait enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("cRTP [wait enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,cRTP)


			/** state (wait) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "wait", "cRTP [wait exit execs]")
				FSM_PROFILE_SECTION_IN ("cRTP [wait exit execs]", state1_exit_exec)
				{
				intrpt_type = op_intrpt_type ();
				
				if (intrpt_type == OPC_INTRPT_STRM)
					intrpt_strm = op_intrpt_strm ();
				
				/*printf ("Header Comp/Decomp %d: Packet received from stream %d.\n", own_objid, intrpt_strm);
				*/
				}
				FSM_PROFILE_SECTION_OUT ("cRTP [wait exit execs]", state1_exit_exec)


			/** state (wait) transition processing **/
			FSM_PROFILE_SECTION_IN ("cRTP [wait trans conditions]", state1_trans_conds)
			FSM_INIT_COND (UNCOMP_PKT_ARRVL)
			FSM_TEST_COND (COMP_PKT_ARRVL)
			FSM_TEST_LOGIC ("wait")
			FSM_PROFILE_SECTION_OUT ("cRTP [wait trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "UNCOMP_PKT_ARRVL", "", "wait", "compressor")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "COMP_PKT_ARRVL", "", "wait", "decompressor")
				}
				/*---------------------------------------------------------*/



			/** state (compressor) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "compressor", "cRTP [compressor enter execs]")
				FSM_PROFILE_SECTION_IN ("cRTP [compressor enter execs]", state2_enter_exec)
				{
				/* Compresses the incoming network packet into the appropriate packet format
				   and creates or updates the session state information. */
				
				error = 0;
				canCompRTP = 0;
				canCompUDPIP = 0;
				
				/* Wait until the context state list is no longer being updated. */
				while (compContextStateUpdating)
					{
					i = 0;
					while (i < 100)
						i++;
					}
				
				/* Obtain a packet arriving from the network (IP) layer. */
				orig_pkptr = op_pk_get (intrpt_strm);
				if (orig_pkptr == OPC_NIL)
					{
					printf ("Compressor %d: ERROR getting packet from input stream %d.\n", own_objid, intrpt_strm);
					}
				
				pk_size = op_pk_total_size_get (orig_pkptr);
				op_pk_format (orig_pkptr, fmt_name);
				
				if (VERBOSE_X)
					printf ("Compressor %d: %s packet received from stream %d.\n", own_objid, fmt_name, intrpt_strm);
				
				/* Compute total size of packet bytes 					*/
				pk_size = op_pk_total_size_get (orig_pkptr);
				byte_load = (pk_size / 8.0);
				
				/* Calculate Sent Traffic statistics.					*/
				op_stat_write (rcvd_comp_packet_handle, 1.0);
				op_stat_write (rcvd_comp_byte_handle, byte_load);
				
				/* Verify if it's an IP packet. */
				
				if (strcmp (fmt_name, "ip_v4_pkt") == 0)
					{
					ip_pkptr = orig_pkptr;
				
					op_pk_nfd_access (ip_pkptr, "version", &newPktFields.ip_version); 
					op_pk_nfd_access (ip_pkptr, "ihl", &newPktFields.ip_ihl); 
					op_pk_nfd_access (ip_pkptr, "tos", &newPktFields.ip_tos); 
					op_pk_nfd_access (ip_pkptr, "length", &newPktFields.ip_length); 
					op_pk_nfd_access (ip_pkptr, "ident", &newPktFields.ip_ident); 
					op_pk_nfd_access (ip_pkptr, "flags", &newPktFields.ip_flags); 
					op_pk_nfd_access (ip_pkptr, "frag_offset", &newPktFields.ip_frag_offset); 
					op_pk_nfd_access (ip_pkptr, "ttl", &newPktFields.ip_ttl); 
					op_pk_nfd_access (ip_pkptr, "protocol", &newPktFields.ip_protocol); 
					op_pk_nfd_access (ip_pkptr, "header_checksum", &newPktFields.ip_header_checksum); 
					op_pk_nfd_access (ip_pkptr, "src_addr", &newPktFields.ip_src_addr); 
					op_pk_nfd_access (ip_pkptr, "dest_addr", &newPktFields.ip_dest_addr); 
					op_pk_nfd_get (ip_pkptr, "data", &data_pkptr);
				
					if (VERBOSE_XXX)
						{
						printf ("Compressor %d: newPktFields.ip_tos = %d.\n", own_objid, newPktFields.ip_tos);
						printf ("Compressor %d: newPktFields.ip_length = %d.\n", own_objid, newPktFields.ip_length);
						printf ("Compressor %d: newPktFields.ip_ident = %d.\n", own_objid, newPktFields.ip_ident);
						printf ("Compressor %d: newPktFields.ip_frag_offset = %d.\n", own_objid, newPktFields.ip_frag_offset);
						printf ("Compressor %d: newPktFields.ip_ttl = %d.\n", own_objid, newPktFields.ip_ttl);
						printf ("Compressor %d: newPktFields.ip_protocol = %d.\n", own_objid, newPktFields.ip_protocol);
						printf ("Compressor %d: newPktFields.ip_src_addr = %d.\n", own_objid, newPktFields.ip_src_addr);
						printf ("Compressor %d: newPktFields.ip_dest_addr = %d.\n", own_objid, newPktFields.ip_dest_addr);
						}
					
					op_pk_format (data_pkptr, fmt_name);
					}
				
				if (strcmp (fmt_name, "udp_v2_pkt") == 0)
					{
					udp_pkptr = data_pkptr;
				
					op_pk_nfd_access (udp_pkptr, "src_port", &newPktFields.udp_src_port);
					op_pk_nfd_access (udp_pkptr, "dest_port", &newPktFields.udp_dest_port);
					op_pk_nfd_access (udp_pkptr, "length", &newPktFields.udp_length);
					op_pk_nfd_access (udp_pkptr, "checksum", &newPktFields.udp_checksum);
				
					if (VERBOSE_XXX)
						{
						printf ("Compressor %d: newPktFields.udp_src_port = %d.\n", own_objid, newPktFields.udp_src_port);
						printf ("Compressor %d: newPktFields.udp_dest_port = %d.\n", own_objid, newPktFields.udp_dest_port);
						printf ("Compressor %d: newPktFields.udp_length = %d.\n", own_objid, newPktFields.udp_length);
						printf ("Compressor %d: newPktFields.udp_checksum = %d.\n", own_objid, newPktFields.udp_checksum);
						}
					
					op_pk_nfd_get (udp_pkptr, "data", &data_pkptr);
				
					pk_size = op_pk_total_size_get (data_pkptr);
					op_pk_format (data_pkptr, fmt_name);
					}
				
				if (strcmp (fmt_name, "rtp_pkt") == 0)
					{
					rtp_pkptr = data_pkptr;
					op_pk_nfd_access (rtp_pkptr, "version", &newPktFields.rtp_version);
					op_pk_nfd_access (rtp_pkptr, "padding", &newPktFields.rtp_padding);
					op_pk_nfd_access (rtp_pkptr, "extension", &newPktFields.rtp_extension);
					op_pk_nfd_access (rtp_pkptr, "csrc_count", &newPktFields.rtp_csrc_count);
					op_pk_nfd_access (rtp_pkptr, "marker", &newPktFields.rtp_marker);
					op_pk_nfd_access (rtp_pkptr, "payload_type", &newPktFields.rtp_payload_type);
					op_pk_nfd_access (rtp_pkptr, "seq_number", &newPktFields.rtp_seq_number);
					op_pk_nfd_access (rtp_pkptr, "timestamp", &newPktFields.rtp_timestamp);
					op_pk_nfd_access (rtp_pkptr, "ssrc_synch_src", &newPktFields.rtp_ssrc);
				
					if (VERBOSE_XXX)
						{
						printf ("Compressor %d: newPktFields.rtp_version = %d.\n", own_objid, newPktFields.rtp_version);
						printf ("Compressor %d: newPktFields.rtp_padding = %d.\n", own_objid, newPktFields.rtp_padding);
						printf ("Compressor %d: newPktFields.rtp_extension = %d.\n", own_objid, newPktFields.rtp_extension);
						printf ("Compressor %d: newPktFields.rtp_csrc_count = %d.\n", own_objid, newPktFields.rtp_csrc_count);
						printf ("Compressor %d: newPktFields.rtp_marker = %d.\n", own_objid, newPktFields.rtp_marker);
						printf ("Compressor %d: newPktFields.rtp_payload_type = %d.\n", own_objid, newPktFields.rtp_payload_type);
						printf ("Compressor %d: newPktFields.rtp_seq_number = %d.\n", own_objid, newPktFields.rtp_seq_number);
						printf ("Compressor %d: newPktFields.rtp_timestamp = %d.\n", own_objid, newPktFields.rtp_timestamp);
						printf ("Compressor %d: newPktFields.rtp_ssrc = %d.\n", own_objid, newPktFields.rtp_ssrc);
						}
				
					op_pk_nfd_get (rtp_pkptr, "data", &payload_pkptr);
					pk_size = op_pk_total_size_get (payload_pkptr);
					}
				
				found = NOT_FOUND;
				xmtListSize = op_prg_list_size (contextStateXmtList);
				if (xmtListSize > 0)
					{
					i = OPC_LISTPOS_HEAD;
					while ((i < xmtListSize) && (found == NOT_FOUND))
						{
						retContextStatePtr = op_prg_list_access (contextStateXmtList, i);
				
						if (VERBOSE_XXX)
							{
							printf ("Compressor %d: contextStateXmtList index %d.\n", own_objid, i);
							printf ("Compressor %d: retContextStatePtr->context_id %d.\n", own_objid, retContextStatePtr->context_id);
							printf ("Compressor %d: retContextStatePtr->link_seq %d.\n", own_objid, retContextStatePtr->link_seq);
							printf ("Compressor %d: retContextStatePtr->last_packet %d.\n", own_objid, retContextStatePtr->last_packet);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_version %d.\n", own_objid, retContextStatePtr->headerInfo.ip_version);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_ihl %d.\n", own_objid, retContextStatePtr->headerInfo.ip_ihl);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_tos %d.\n", own_objid, retContextStatePtr->headerInfo.ip_tos);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_length %d.\n", own_objid, retContextStatePtr->headerInfo.ip_length);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_ident %d.\n", own_objid, retContextStatePtr->headerInfo.ip_ident);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_flags %d.\n", own_objid, retContextStatePtr->headerInfo.ip_flags);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_frag_offset %d.\n", own_objid, retContextStatePtr->headerInfo.ip_frag_offset);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_ttl %d.\n", own_objid, retContextStatePtr->headerInfo.ip_ttl);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_protocol %d.\n", own_objid, retContextStatePtr->headerInfo.ip_protocol);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_header_checksum %d.\n", own_objid, retContextStatePtr->headerInfo.ip_header_checksum);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_src_addr %d.\n", own_objid, retContextStatePtr->headerInfo.ip_src_addr);
							printf ("Compressor %d: retContextStatePtr->headerInfo.ip_dest_addr %d.\n", own_objid, retContextStatePtr->headerInfo.ip_dest_addr);
							printf ("Compressor %d: retContextStatePtr->headerInfo.udp_src_port %d.\n", own_objid, retContextStatePtr->headerInfo.udp_src_port);
							printf ("Compressor %d: retContextStatePtr->headerInfo.udp_dest_port %d.\n", own_objid, retContextStatePtr->headerInfo.udp_dest_port);
							printf ("Compressor %d: retContextStatePtr->headerInfo.udp_length %d.\n", own_objid, retContextStatePtr->headerInfo.udp_length);
							printf ("Compressor %d: retContextStatePtr->headerInfo.udp_checksum %d.\n", own_objid, retContextStatePtr->headerInfo.udp_checksum);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_version %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_version);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_padding %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_padding);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_extension %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_extension);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_csrc_count %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_csrc_count);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_marker %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_marker);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_payload_type %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_payload_type);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_seq_number %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_seq_number);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_timestamp %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_timestamp);
							printf ("Compressor %d: retContextStatePtr->headerInfo.rtp_ssrc %d.\n", own_objid, retContextStatePtr->headerInfo.rtp_ssrc);
							printf ("Compressor %d: retContextStatePtr->fieldDeltas.delta_ip_id %d.\n", own_objid, retContextStatePtr->fieldDeltas.delta_ip_id);
							printf ("Compressor %d: retContextStatePtr->fieldDeltas.delta_rtp_ts %d.\n", own_objid, retContextStatePtr->fieldDeltas.delta_rtp_ts);
							printf ("Compressor %d: retContextStatePtr->fieldDeltas.delta_rtp_seq %d.\n", own_objid, retContextStatePtr->fieldDeltas.delta_rtp_seq);
							}
						if ((retContextStatePtr->headerInfo.ip_src_addr == newPktFields.ip_src_addr)
							&& (retContextStatePtr->headerInfo.ip_dest_addr == newPktFields.ip_dest_addr)
							&& (retContextStatePtr->headerInfo.udp_src_port == newPktFields.udp_src_port)
							&& (retContextStatePtr->headerInfo.udp_dest_port == newPktFields.udp_dest_port)
							&& (retContextStatePtr->headerInfo.rtp_ssrc == newPktFields.rtp_ssrc))
							{
							found = FOUND;
							foundIndex = i;
							}
						i++;
						}
					}
				
				if (found == NOT_FOUND)
					{
					if (newPktFields.rtp_marker == 0)
						{
						error = 1;					/* Must have Marker set if it is the first packet. */
						errorCountComp++;
						}
				
					if (!xmtListSize)				/* If no Contexts */
						{
						newCID = 0;
						}
					else
						{
						/* Find the first unused CID integer. */
						i = OPC_LISTPOS_HEAD;
						if (CID8)
							{
							CIDavail = 0;				/* Set flag to ensure that the "for" loop is entered. */
							for (newCID = -1; (newCID < MAX_NUM_CID8) && (!CIDavail);)
								{
								newCID++;
								CIDavail = 1;			/* Assume the newCID CID is available. */
								for (i = 0; (i < xmtListSize) && (CIDavail); i++)
									{
									retContextStatePtr = op_prg_list_access (contextStateXmtList, i);
									if (retContextStatePtr->context_id == newCID)
										{
										CIDavail = 0;	/* CID is not available. */
										}
									}
								}
							}
						if (CID16)
							{
							CIDavail = 0;				/* Set flag to ensure that the "for" loop is entered. */
							for (newCID = -1; (newCID < MAX_NUM_CID16) && (!CIDavail);)
								{
								newCID++;
								CIDavail = 1;			/* Assume the newCID CID is available. */
								for (i = 0; (i < xmtListSize) && (CIDavail); i++)
									{
									retContextStatePtr = op_prg_list_access (contextStateXmtList, i);
									if (retContextStatePtr->context_id == newCID)
										{
										CIDavail = 0;	/* CID is not available. */
										}
									}
								}
							}
						}
					
					if (!error)
						{
						/* Create new Context State list element with default delta values. */
						tempContextStatePtr = op_prg_mem_alloc (sizeof(CONTEXT_STATE_INFO));
						tempContextStatePtr->headerInfo = newPktFields;
						tempContextStatePtr->fieldDeltas.delta_ip_id = 1;
						tempContextStatePtr->fieldDeltas.delta_rtp_ts = 0;
						tempContextStatePtr->fieldDeltas.delta_rtp_seq = 1;
						tempContextStatePtr->context_id = newCID;
						tempContextStatePtr->link_seq = 0;			/* init the link sequence to 0. */
						tempContextStatePtr->last_packet = 0; 		/* last packet not received yet. */
						tempContextStatePtr->invalid = 0;			/* invalid state flag not used in compressor */
						tempContextStatePtr->sendFullNext = 0;		/* reset sendFullNext flag */
						
						op_prg_list_insert (contextStateXmtList, tempContextStatePtr, OPC_LISTPOS_TAIL);
				
						if (VERBOSE_0)
							printf ("\nCompressor %d: CID %d assigned to source with SSRC %d.\n", own_objid, newCID, newPktFields.rtp_ssrc);
						
						/* Reformulate FULL_HEADER packet. */
						op_pk_nfd_set (rtp_pkptr, "data", payload_pkptr);
						op_pk_nfd_set (udp_pkptr, "data", rtp_pkptr);
				
						if (CID8)
							{
							op_pk_nfd_set (udp_pkptr, "length", tempContextStatePtr->link_seq);
							op_pk_nfd_set (ip_pkptr, "data", udp_pkptr);
							op_pk_nfd_set (ip_pkptr, "length", tempContextStatePtr->context_id);
							}
						else if (CID16)
							{
							op_pk_nfd_set (udp_pkptr, "length", tempContextStatePtr->context_id);
							op_pk_nfd_set (ip_pkptr, "data", udp_pkptr);
							op_pk_nfd_set (ip_pkptr, "length", tempContextStatePtr->link_seq);
							}
					
						/* Compute total size of packet bytes 					*/
						pk_size = (double) op_pk_total_size_get (ip_pkptr);
						byte_load = (pk_size / 8.0);
				
						/* Calculate Sent Traffic statistics.					*/
						op_stat_write (sent_comp_packet_handle, 1.0);
						op_stat_write (sent_comp_byte_handle, byte_load);
				
						/* Send packet to network. */
						op_pk_send (ip_pkptr, COMP_OUT_STRM);
				
						if (VERBOSE_XX)
							printf ("Compressor %d: Packet of size %d sent to COMP_OUT_STRM.\n", own_objid, pk_size);
				
						} /* End of "if (!error)" */
					else
						{
						if (error == 1)
							{
							if (VERBOSE_ERR)
								printf ("Compressor %d: ERROR -- Marker bit not set on first packet.\n", own_objid);
							}
						if (error == 2)
							{
							if (VERBOSE_ERR)
								printf ("Compressor %d: ERROR -- maximum number of CIDs have been used.\n", own_objid);
							}
						}
					}	/* End of "if (found == NOT_FOUND)" */
				
				else if (found == FOUND)
					{
					/* Session State exists and is list element foundIndex and pointed to by retContextStatePtr. */
					/* Update some elements of the session context. */
					
					if (retContextStatePtr->link_seq == 15)
						{
						retContextStatePtr->link_seq = 0;
						}
					else
						{
						retContextStatePtr->link_seq = retContextStatePtr->link_seq + 1;
						}
					
					if (newPktFields.rtp_marker == 1)
						{
						retContextStatePtr->last_packet = 1;
						}
					if (VERBOSE_XX)
						printf ("Compressor %d: link sequence number is now %d.\n", own_objid, retContextStatePtr->link_seq);
					
					/* Check whether we can do RTP compression. */
					if ((retContextStatePtr->headerInfo.rtp_version == newPktFields.rtp_version)
						&& (retContextStatePtr->headerInfo.rtp_padding == newPktFields.rtp_padding)
						&& (retContextStatePtr->headerInfo.rtp_extension == newPktFields.rtp_extension)
						&& (retContextStatePtr->headerInfo.rtp_csrc_count == newPktFields.rtp_csrc_count)
						&& (retContextStatePtr->headerInfo.rtp_payload_type == newPktFields.rtp_payload_type))
						{
						canCompRTP = 1;
						if (VERBOSE_XX)
							printf ("Compressor %d CID %d: RTP Compression can be done.\n", own_objid, retContextStatePtr->context_id);
						}
						
					if ((retContextStatePtr->headerInfo.ip_version == newPktFields.ip_version)
						&& (retContextStatePtr->headerInfo.ip_ihl == newPktFields.ip_ihl)
						&& (retContextStatePtr->headerInfo.ip_tos == newPktFields.ip_tos)
						&& (retContextStatePtr->headerInfo.ip_flags == newPktFields.ip_flags)
						&& (retContextStatePtr->headerInfo.ip_ttl == newPktFields.ip_ttl)
						&& (retContextStatePtr->headerInfo.ip_protocol == newPktFields.ip_protocol))
						{
						canCompUDPIP = 1;
						if (VERBOSE_XX)
							printf ("Compressor %d CID %d: UDP/IP Compression can be done.\n", own_objid, retContextStatePtr->context_id);
						}
				
					/* Find the new delta values. */
					delta_rtp_ts = newPktFields.rtp_timestamp - retContextStatePtr->headerInfo.rtp_timestamp;
					
					if (VERBOSE_XXX)
						printf ("Compressor %d CID %d: New delta_rtp_ts = %d\n", own_objid, retContextStatePtr->context_id, delta_rtp_ts);
					delta_rtp_seq = newPktFields.rtp_seq_number - retContextStatePtr->headerInfo.rtp_seq_number;
					if (VERBOSE_XXX)
						printf ("Compressor %d CID %d: New delta_rtp_seq = %d\n", own_objid, retContextStatePtr->context_id, delta_rtp_seq);
					delta_ip_id = newPktFields.ip_ident - retContextStatePtr->headerInfo.ip_ident;
					if (VERBOSE_XXX)
						printf ("Compressor %d CID %d: New delta_ip_id = %d\n", own_objid, retContextStatePtr->context_id, delta_ip_id);
				
					rtp_ts_changed = 0;
					rtp_seq_changed = 0;
					ip_id_changed = 0;
				
					/******************************* Can do full RTP/UDP/IP compression. *******************************/
					if (canCompRTP && canCompUDPIP && !(retContextStatePtr->sendFullNext))
						{
						if (VERBOSE_XX)
							printf ("Compressor %d: Full compression being done...\n", own_objid);
				
						/* Add changing delta fields as required. */
						if (delta_ip_id != retContextStatePtr->fieldDeltas.delta_ip_id)
							{
							if (VERBOSE_XXX)
								printf ("new delta_ip_id = %d, old delta_ip_id = %d\n", delta_ip_id, retContextStatePtr->fieldDeltas.delta_ip_id);
							ip_id_changed = 1;
							}
						
						if (delta_rtp_seq != retContextStatePtr->fieldDeltas.delta_rtp_seq)
							{
							if (VERBOSE_XXX)
								printf ("new delta_rtp_seq = %d, old delta_rtp_seq = %d\n", delta_rtp_seq, retContextStatePtr->fieldDeltas.delta_rtp_seq);
							rtp_seq_changed = 1;
							}
				
						if (delta_rtp_ts != retContextStatePtr->fieldDeltas.delta_rtp_ts)
							{
							if (VERBOSE_XXX)
								printf ("new delta_rtp_ts = %d, old delta_rtp_ts = %d\n", delta_rtp_ts, retContextStatePtr->fieldDeltas.delta_rtp_ts);
							rtp_ts_changed = 1;
							}
				
						/* Now create the new fully compressed packet. */
						data_pkptr = op_pk_create_fmt ("compressed_rtp");
					
						if (csrcCountAndList ||
							(newPktFields.rtp_marker && rtp_seq_changed && rtp_ts_changed && ip_id_changed))
							{
							op_pk_nfd_set (data_pkptr, "M", 1);
							op_pk_nfd_set (data_pkptr, "S", 1);
							op_pk_nfd_set (data_pkptr, "T", 1);
							op_pk_nfd_set (data_pkptr, "I", 1);
							}
						else
							{
							op_pk_nfd_set (data_pkptr, "M", newPktFields.rtp_marker);
							op_pk_nfd_set (data_pkptr, "S", rtp_seq_changed);
							op_pk_nfd_set (data_pkptr, "T", rtp_ts_changed);
							op_pk_nfd_set (data_pkptr, "I", ip_id_changed);
							}
				
						if (CID8)
							{
							op_pk_nfd_set (data_pkptr, "session_cid_lsb", retContextStatePtr->context_id);
							}
						else if (CID16)
							{
							op_pk_nfd_set (data_pkptr, "session_cid_lsb", (retContextStatePtr->context_id & 0xFF));
							op_pk_nfd_set (data_pkptr, "session_cid_msb", (retContextStatePtr->context_id >> 8));
							}
							
						op_pk_nfd_set (data_pkptr, "link_seq", retContextStatePtr->link_seq);
						
						/* Add changing delta fields as required. */
						if (ip_id_changed)
							{
							op_pk_nfd_set (data_pkptr, "delta_IPv4_id", delta_ip_id);
				
							/* Update session context. */
							retContextStatePtr->fieldDeltas.delta_ip_id = delta_ip_id;
							}
				
						if (rtp_seq_changed)
							{
							op_pk_nfd_set (data_pkptr, "delta_rtp_seq", delta_rtp_seq);
				
							/* Update session context. */
						   	retContextStatePtr->fieldDeltas.delta_rtp_seq = delta_rtp_seq;
							}
				
						if (rtp_ts_changed)
							{
							op_pk_nfd_set (data_pkptr, "delta_rtp_ts", delta_rtp_ts);
				
							/* Update session context. */
							retContextStatePtr->fieldDeltas.delta_rtp_ts = delta_rtp_ts;
							}
						
						/* csrcCountAndList is not used (set to 0) but is here for future expansion. */		
						/* Check if MSTI = 1111 based on deltas, which can happen by chance.  If so, add
						   M'S'T'I' and CC field. */
						if (csrcCountAndList || 
							(newPktFields.rtp_marker && rtp_seq_changed && rtp_ts_changed && ip_id_changed))
							{
							/* Need to add a new csrc_count field to packet. */
							op_pk_nfd_set (data_pkptr, "M1", newPktFields.rtp_marker);
							op_pk_nfd_set (data_pkptr, "S1", rtp_seq_changed);
							op_pk_nfd_set (data_pkptr, "T1", rtp_ts_changed);
							op_pk_nfd_set (data_pkptr, "I1", ip_id_changed);
							op_pk_nfd_set (data_pkptr, "csrc_count", new_csrc_count);
							
							/* A little more is required here to make this complete.
							   Another field must be created to relay a new CSRC list if
							   necessary. */
							}
				
						op_pk_nfd_set (data_pkptr, "rtp_data", payload_pkptr);
						
						/* Compute total size of packet bytes 					*/
						pk_size = (double) op_pk_total_size_get (data_pkptr);
						byte_load = (pk_size / 8.0);
				
						/* Calculate Sent Traffic statistics.					*/
						op_stat_write (sent_comp_packet_handle, 1.0);
						op_stat_write (sent_comp_byte_handle, byte_load);
						
						/* Send packet to network. */
						op_pk_send (data_pkptr, COMP_OUT_STRM);
						
						op_pk_destroy (ip_pkptr);
						op_pk_destroy (udp_pkptr);
						op_pk_destroy (rtp_pkptr);
						}	/* End of "if (canCompRTP && canCompUDPIP)" */
				
					/******************************* Can only do UDP/IP compression. *******************************/
					if (!canCompRTP && canCompUDPIP && !(retContextStatePtr->sendFullNext))
						{
				
						op_pk_nfd_set (rtp_pkptr, "data", payload_pkptr);
						payload_pkptr = rtp_pkptr;
				
						/* Add changing delta fields as required. */
						if (delta_ip_id != retContextStatePtr->fieldDeltas.delta_ip_id)
							{
							if (VERBOSE_XXX)
								printf ("new delta_ip_id = %d, old delta_ip_id = %d\n", delta_ip_id, retContextStatePtr->fieldDeltas.delta_ip_id);
							ip_id_changed = 1;
							}
						
						/* Now create the new UDP/IP compressed packet. */
						data_pkptr = op_pk_create_fmt ("compressed_udp");
						op_pk_nfd_set (data_pkptr, "M", 0);
						op_pk_nfd_set (data_pkptr, "S", 0);
						op_pk_nfd_set (data_pkptr, "T", 0);
						op_pk_nfd_set (data_pkptr, "I", ip_id_changed);
				
						if (CID8)
							{
							op_pk_nfd_set (data_pkptr, "session_cid_lsb", retContextStatePtr->context_id);
							}
						else if (CID16)
							{
							op_pk_nfd_set (data_pkptr, "session_cid_lsb", (retContextStatePtr->context_id & 0xFF));
							op_pk_nfd_set (data_pkptr, "session_cid_msb", (retContextStatePtr->context_id >> 8));
							}
						op_pk_nfd_set (data_pkptr, "link_seq", retContextStatePtr->link_seq);
				
						/* Add changing delta field as required. */
						if (ip_id_changed)
							{
							/* Need to add a new delta_ip_id field to packet. */
							op_pk_nfd_set (data_pkptr, "delta_IPv4_id", delta_ip_id);
				
							/* Need to update session context. */
							retContextStatePtr->fieldDeltas.delta_ip_id = delta_ip_id;
							}
				
						op_pk_nfd_set (data_pkptr, "udp_data", payload_pkptr);
				
						/* Compute total size of packet bytes 					*/
						pk_size = (double) op_pk_total_size_get (data_pkptr);
						byte_load = (pk_size / 8.0);
				
						/* Calculate Sent Traffic statistics.					*/
						op_stat_write (sent_comp_packet_handle, 1.0);
						op_stat_write (sent_comp_byte_handle, byte_load);
						
						/* Send packet to network. */
						op_pk_send (data_pkptr, COMP_OUT_STRM);
				
						op_pk_destroy (ip_pkptr);
						op_pk_destroy (udp_pkptr);
						}	/* End of "if (!canCompRTP && canCompUDPIP)" */
				
					/******************************* Can't do any compression. *******************************/
					if (!canCompUDPIP || retContextStatePtr->sendFullNext)
						{
						/* Debugging output. */
						if (retContextStatePtr->sendFullNext)
							{
							if (VERBOSE_1)
								printf ("Compressor %d: CID %d required a full header packet - served.\n", own_objid, retContextStatePtr->context_id);
				
							/* Reset sendFullNext flag. */
							retContextStatePtr->sendFullNext = 0;
							}		
						
						/* Add changing delta fields as required. */
						retContextStatePtr->headerInfo = newPktFields;
						retContextStatePtr->fieldDeltas.delta_ip_id = 1;
						retContextStatePtr->fieldDeltas.delta_rtp_ts = 0;
						retContextStatePtr->fieldDeltas.delta_rtp_seq = 1;
						retContextStatePtr->last_packet = newPktFields.rtp_marker;
						
						if (retContextStatePtr->link_seq != 15)
							retContextStatePtr->link_seq++;
						else if (retContextStatePtr->link_seq == 15)
							retContextStatePtr->link_seq = 0;
				
						op_pk_nfd_set (rtp_pkptr, "data", payload_pkptr);
						op_pk_nfd_set (udp_pkptr, "data", rtp_pkptr);
				
						if (CID8)
							{
							op_pk_nfd_set (udp_pkptr, "length", retContextStatePtr->link_seq);
							op_pk_nfd_set (ip_pkptr, "data", udp_pkptr);
							op_pk_nfd_set (ip_pkptr, "length", retContextStatePtr->context_id);
							}
						else if (CID16)
							{
							op_pk_nfd_set (udp_pkptr, "length", retContextStatePtr->context_id);
							op_pk_nfd_set (ip_pkptr, "data", udp_pkptr);
							op_pk_nfd_set (ip_pkptr, "length", retContextStatePtr->link_seq);
							}
				
						/* Compute total size of packet bytes 					*/
						pk_size = (double) op_pk_total_size_get (ip_pkptr);
						byte_load = (pk_size / 8.0);
				
						/* Calculate Sent Traffic statistics.					*/
						op_stat_write (sent_comp_packet_handle, 1.0);
						op_stat_write (sent_comp_byte_handle, byte_load);
				
						/* Send packet to network. */
						op_pk_send (ip_pkptr, COMP_OUT_STRM);
				
						if (VERBOSE_1)
							printf ("Compressor %d: Sent FULL HEADER for CID %d *****************************\n", own_objid, retContextStatePtr->context_id);
						
						}	/* End of "if (!canCompUDPIP)" */	
				
				
					/* Update the context state with the new header values. */
					retContextStatePtr->headerInfo = newPktFields;
					
					/* Remove this context state from the context state list if the
					   last packet has been sent. */
					if (retContextStatePtr->last_packet)
						{
						compContextStateUpdating = 1;
				
						if (VERBOSE_0)
							printf ("Compressor %d: Removing CID %d (SSRC %d) from Context State Table... ",
								own_objid, retContextStatePtr->context_id, retContextStatePtr->headerInfo.rtp_ssrc);
						
						op_prg_list_remove (contextStateXmtList, foundIndex);
				
						printf ("DONE.\n");
				
						if (op_prg_list_size (contextStateXmtList) == 0)
							{
							if (VERBOSE_0)
								printf ("Compressor %d: That was the last element of contextStateXmtList.\n", own_objid);
							}
						compContextStateUpdating = 0;
						}
					}	/* End of "if (found == FOUND)" */
				}

				FSM_PROFILE_SECTION_OUT ("cRTP [compressor enter execs]", state2_enter_exec)

			/** state (compressor) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "compressor", "cRTP [compressor exit execs]")
				FSM_PROFILE_SECTION_IN ("cRTP [compressor exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cRTP [compressor exit execs]", state2_exit_exec)


			/** state (compressor) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "compressor", "wait")
				/*---------------------------------------------------------*/



			/** state (decompressor) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "decompressor", "cRTP [decompressor enter execs]")
				FSM_PROFILE_SECTION_IN ("cRTP [decompressor enter execs]", state3_enter_exec)
				{
				/* Receives packets from the compression network, reassembles the
				   original RTP/UDP/IP packets, and sends them into the IP network. */
				
				/*printf (".");*/
				
				error = 0;
				droppedPacket = 0;
				pktFmtError = 0;
				
				/* Wait until the context state list is no longer being updated. */
				while (decompContextStateUpdating)
					{
				/*	printf ("Waiting for decompressor context state to finish updating.\n");
				*/	i = 0;
					while (i < 100)
						i++;
					}
				/* Obtain a packet arriving from the compression stream network. */
				orig_pkptr = op_pk_get (intrpt_strm);
				/* Compute total size of packet bytes 					*/
				pk_size = op_pk_total_size_get (orig_pkptr);
				byte_load = (pk_size / 8.0);
				
				/* Calculate Sent Traffic statistics.					*/
				op_stat_write (rcvd_decomp_packet_handle, 1.0);
				op_stat_write (rcvd_decomp_byte_handle, byte_load);
				
				op_pk_format (orig_pkptr, recv_fmt_name);
				pk_size = op_pk_total_size_get (orig_pkptr);
				
				if (VERBOSE_XX)
					printf ("Decompressor %d: Packet format is %s with size %d.\n", own_objid, recv_fmt_name, pk_size);
				
				/* Check type of packet. */
				if ((strcmp (recv_fmt_name, "context_state_8") == 0) || (strcmp (recv_fmt_name, "context_state_16") == 0))
					{
					data_pkptr = orig_pkptr;
					
				  	op_pk_nfd_access (data_pkptr, "session_context_id", &rcvd_context_id);
					op_pk_nfd_access (data_pkptr, "sequence", &rcvd_link_seq);
					
					found = NOT_FOUND;
					xmtListSize = op_prg_list_size(contextStateXmtList);
					if (xmtListSize > 0)
						{
						i = OPC_LISTPOS_HEAD;
						while ((i < xmtListSize) && (found == NOT_FOUND))
							{
							retContextStatePtr = op_prg_list_access (contextStateXmtList, i);
							if (rcvd_context_id == retContextStatePtr->context_id)
								{
								found = FOUND;
								foundIndex = i;
								}
							i++;
							}
						}
				
					if (found == NOT_FOUND)
						{
						/* Shouldn't receive a context state packet if context state does not exist. */
						error = 1;
						errorCountDecomp++;
						if (VERBOSE_ERR)
							printf ("Decompressor %d: ERROR - context state (CID %d) for CONTEXT_STATE packet not found.\n", own_objid, rcvd_context_id);
				
						/* Destroy the received packet.	*/
						op_pk_destroy (data_pkptr);		
						}
					if (found == FOUND)
						{
						op_stat_write (rcvd_context_state_handle, 1.0);
						
						if (VERBOSE_1)
							printf ("Decompressor %d: Received CONTEXT_STATE packet for CID %d.\n", own_objid, retContextStatePtr->context_id);
				
						retContextStatePtr->sendFullNext = 1;
				
						/* Destroy the received packet.	*/
						op_pk_destroy (data_pkptr);		
						}
					}
				
				if ((strcmp (recv_fmt_name, "compressed_rtp") == 0) || (strcmp (recv_fmt_name, "compressed_udp") == 0))
					{
					data_pkptr = orig_pkptr;
				
					strcpy (fmt_name, recv_fmt_name);
					
					if (CID8)
						{
						op_pk_nfd_access (data_pkptr, "session_cid_lsb", &rcvd_context_id);
						}
					else if (CID16)
						{
						op_pk_nfd_access (data_pkptr, "session_cid_lsb", &rcvd_context_id_lsb);
						op_pk_nfd_access (data_pkptr, "session_cid_msb", &rcvd_context_id_msb);
						rcvd_context_id = (rcvd_context_id_msb << 8) & rcvd_context_id_lsb;
						}
					op_pk_nfd_access (data_pkptr, "link_seq", &rcvd_link_seq);
				
					found = NOT_FOUND;
					rcvListSize = op_prg_list_size(contextStateRcvList);
					if (rcvListSize > 0)
						{
						i = OPC_LISTPOS_HEAD;
						while ((i < rcvListSize) && (found == NOT_FOUND))
							{
							retContextStatePtr = op_prg_list_access (contextStateRcvList, i);
							if (rcvd_context_id == retContextStatePtr->context_id)
								{
								found = FOUND;
								foundIndex = i;
								}
							i++;
							}
						}
				
					if (found == NOT_FOUND)
						{
						/* Shouldn't be of compressed format as the first stream packet. */
						error = 1;
						errorCountDecomp++;
				
						/* Destroy the received packet.	*/
						op_pk_destroy (data_pkptr);		
				
						printf ("Decompressor %d: ERROR - CID %d for compressed packet not found.\n", own_objid, rcvd_context_id);
						}
					else if ((found == FOUND) && (retContextStatePtr->invalid == CONTEXT_STATE_MAX_RETRY))
						{
						/* Record Dropped Packet statistics.					*/
						op_stat_write (packet_dropped_handle, 1.0);
				
						/* Packet is dropped. */
						if (VERBOSE_1)
							printf ("Decompressor %d: Packet for invalidated context state CID %d dropped.\n",own_objid, retContextStatePtr->context_id);
				
						/* Destroy the received packet.	*/
						op_pk_destroy (data_pkptr);		
						}
					else if ((found == FOUND) && (retContextStatePtr->invalid < CONTEXT_STATE_MAX_RETRY))
						{
						/* Session State exists and is list element foundIndex and pointed to by retContextStatePtr. */
						/* Update some elements of the session context. */
				
						/* Check for dropped packets. */
						if (!((rcvd_link_seq - retContextStatePtr->link_seq == 1)
							|| ((rcvd_link_seq == 0) && retContextStatePtr->link_seq == 15)))
							{
							droppedPacket = 1;
				
							/* Record Dropped Packet statistics.					*/
							op_stat_write (packet_dropped_handle, 1.0);
				
							/* Destroy the received packet.	*/
							op_pk_destroy (data_pkptr);		
				
							totalDroppedPackets++;
							if (VERBOSE_1)
								printf ("Decompressor %d: ERROR - dropped packet detected in CID %d. Tossing this packet.\n", own_objid, retContextStatePtr->context_id);
							}
				
						if (droppedPacket)
							{
							/* Create a CONTEXT_STATE packet to send to compressor side */
							if (CID8)
								{
								data_pkptr = op_pk_create_fmt ("context_state_8");
								op_pk_nfd_set (data_pkptr, "8or16bit_CID", 1);
								op_pk_nfd_set (data_pkptr, "context_count", 1);
								op_pk_nfd_set (data_pkptr, "session_context_id", retContextStatePtr->context_id);
								op_pk_nfd_set (data_pkptr, "sequence", retContextStatePtr->link_seq);
								op_pk_nfd_set (data_pkptr, "generation", 0);
								}
							if (CID16)
								{
								data_pkptr = op_pk_create_fmt ("context_state_16");
								op_pk_nfd_set (data_pkptr, "8or16bit_CID", 2);
								op_pk_nfd_set (data_pkptr, "context_count", 1);
								op_pk_nfd_set (data_pkptr, "session_context_id", retContextStatePtr->context_id);
								op_pk_nfd_set (data_pkptr, "sequence", retContextStatePtr->link_seq);
								op_pk_nfd_set (data_pkptr, "generation", 0);
								}
				
							/* Invalidate context because a packet was dropped. To avoid dropped CONTEXT_STATE packets, up to two are sent. */
							retContextStatePtr->invalid++;
										
							/* Compute total size of Context State packet */
							pk_size = (double) op_pk_total_size_get (data_pkptr);
							byte_load = (pk_size / 8.0);
							
							/* Calculate Sent Traffic statistics.				*/
							op_stat_write (sent_comp_packet_handle, 1.0);
							op_stat_write (sent_comp_byte_handle, byte_load);
							op_stat_write (sent_context_state_handle, 1.0);
							
							/* Send context state packet to compressor. 		*/
							op_pk_send (data_pkptr, COMP_OUT_STRM);
							if (VERBOSE_X)
								printf ("Decompressor %d: Context ID %d, sent CONTEXT_STATE packet (%d) to stream %d.\n", own_objid, retContextStatePtr->context_id, retContextStatePtr->invalid, COMP_OUT_STRM);
							}
						else    /* "if(droppedPacket)" condition */
							{
							/* No general errors. Can now get the new delta fields where necessary. */
							/* Keep data_pkptr as the base pointer to the packet to deal with. */
				
							/********************* Full RTP/UDP/IP compression. ****************************/
							if (strcmp (fmt_name, "compressed_rtp") == 0)
								{
								op_pk_nfd_access (data_pkptr, "M", &tempMSTIfields.mFlag);
								op_pk_nfd_access (data_pkptr, "T", &tempMSTIfields.tFlag);
								op_pk_nfd_access (data_pkptr, "S", &tempMSTIfields.sFlag);
								op_pk_nfd_access (data_pkptr, "I", &tempMSTIfields.iFlag);
				
								if (tempMSTIfields.mFlag || tempMSTIfields.tFlag ||
									tempMSTIfields.sFlag || tempMSTIfields.iFlag)
									if (VERBOSE_XX)
										printf ("MSTI = %d%d%d%d\n", tempMSTIfields.mFlag, tempMSTIfields.tFlag, tempMSTIfields.sFlag, tempMSTIfields.iFlag);
				
								if (tempMSTIfields.mFlag && tempMSTIfields.tFlag &&
									tempMSTIfields.sFlag && tempMSTIfields.iFlag)
									{
									if (VERBOSE_XX)
										printf ("Decompressor %d: packet has M1T1S1I1 components\n", own_objid);
									op_pk_nfd_access (data_pkptr, "M1", &tempMSTIfields.mFlag);
									op_pk_nfd_access (data_pkptr, "T1", &tempMSTIfields.tFlag);
									op_pk_nfd_access (data_pkptr, "S1", &tempMSTIfields.sFlag);
									op_pk_nfd_access (data_pkptr, "I1", &tempMSTIfields.iFlag);
									}
				
								if (tempMSTIfields.iFlag)
									{
									op_pk_nfd_access (data_pkptr, "delta_IPv4_id", &retContextStatePtr->fieldDeltas.delta_ip_id);
									if (VERBOSE_XX)
										printf ("delta_ip_id = %d\n", retContextStatePtr->fieldDeltas.delta_ip_id);
									}				
								
								if (tempMSTIfields.sFlag)
									{
									op_pk_nfd_access (data_pkptr, "delta_rtp_seq", &retContextStatePtr->fieldDeltas.delta_rtp_seq);
									if (VERBOSE_XX)
										printf ("delta_rtp_seq = %d\n", retContextStatePtr->fieldDeltas.delta_rtp_seq);
									}				
								
								if (tempMSTIfields.tFlag && !pktFmtError)
									{
									op_pk_nfd_access (data_pkptr, "delta_rtp_ts", &retContextStatePtr->fieldDeltas.delta_rtp_ts);
									if (VERBOSE_XX)
										printf ("delta_rtp_ts = %d\n", retContextStatePtr->fieldDeltas.delta_rtp_ts);
									}
				
								/* Get the RTP payload. */
								op_pk_nfd_get (data_pkptr, "rtp_data", &payload_pkptr);
				
								/* Update the context state information. */
								retContextStatePtr->headerInfo.ip_ident = 
									retContextStatePtr->headerInfo.ip_ident + retContextStatePtr->fieldDeltas.delta_ip_id;
								retContextStatePtr->headerInfo.rtp_seq_number = 
									retContextStatePtr->headerInfo.rtp_seq_number + retContextStatePtr->fieldDeltas.delta_rtp_seq;
								retContextStatePtr->headerInfo.rtp_timestamp = 
									retContextStatePtr->headerInfo.rtp_timestamp + retContextStatePtr->fieldDeltas.delta_rtp_ts;
								retContextStatePtr->headerInfo.rtp_marker = tempMSTIfields.mFlag;
								retContextStatePtr->link_seq = rcvd_link_seq;
								retContextStatePtr->last_packet = tempMSTIfields.mFlag;
				
								/* Done updating all the state information.*/
				
								/* Create the RTP packet at this point.  The rest will be done later. */
								rtp_pkptr = op_pk_create_fmt ("rtp_pkt");
								op_pk_nfd_set (rtp_pkptr, "version", retContextStatePtr->headerInfo.rtp_version);
								op_pk_nfd_set (rtp_pkptr, "padding", retContextStatePtr->headerInfo.rtp_padding);
								op_pk_nfd_set (rtp_pkptr, "extension", retContextStatePtr->headerInfo.rtp_extension);
								op_pk_nfd_set (rtp_pkptr, "csrc_count", retContextStatePtr->headerInfo.rtp_csrc_count);
								op_pk_nfd_set (rtp_pkptr, "marker", retContextStatePtr->headerInfo.rtp_marker);
								op_pk_nfd_set (rtp_pkptr, "payload_type", retContextStatePtr->headerInfo.rtp_payload_type);
								op_pk_nfd_set (rtp_pkptr, "seq_number", retContextStatePtr->headerInfo.rtp_seq_number);
								op_pk_nfd_set (rtp_pkptr, "timestamp", retContextStatePtr->headerInfo.rtp_timestamp);
								op_pk_nfd_set (rtp_pkptr, "ssrc_synch_src", retContextStatePtr->headerInfo.rtp_ssrc);
								op_pk_nfd_set (rtp_pkptr, "data", payload_pkptr);
				
								}	/* End of "if (fmt_name == "compressed rtp")" */
				
							/********************* UDP/IP compression only. ****************************/
							else if (strcmp (fmt_name, "compressed_udp") == 0)
								{
								op_pk_nfd_access (data_pkptr, "I", &tempMSTIfields.iFlag);
							
								if (tempMSTIfields.iFlag)
									{
									op_pk_nfd_access (data_pkptr, "delta_IPv4_id", &retContextStatePtr->fieldDeltas.delta_ip_id);
									if (VERBOSE_XX)
										printf ("delta_IPv4_id = %d\n", retContextStatePtr->fieldDeltas.delta_ip_id);
									}				
				
								/* Get uncompressed RTP packet. */
								op_pk_nfd_get (data_pkptr, "udp_data", &rtp_pkptr);
								op_pk_format (rtp_pkptr, fmt_name);
				
								if (strcmp (fmt_name, "rtp_pkt") == 0)
									{
									op_pk_nfd_access (rtp_pkptr, "version", &retContextStatePtr->headerInfo.rtp_version);
									op_pk_nfd_access (rtp_pkptr, "padding", &retContextStatePtr->headerInfo.rtp_padding);
									op_pk_nfd_access (rtp_pkptr, "extension", &retContextStatePtr->headerInfo.rtp_extension);
									op_pk_nfd_access (rtp_pkptr, "csrc_count", &retContextStatePtr->headerInfo.rtp_csrc_count);
									op_pk_nfd_access (rtp_pkptr, "marker", &retContextStatePtr->headerInfo.rtp_marker);
									op_pk_nfd_access (rtp_pkptr, "payload_type", &retContextStatePtr->headerInfo.rtp_payload_type);
									op_pk_nfd_access (rtp_pkptr, "seq_number", &retContextStatePtr->headerInfo.rtp_seq_number);
									op_pk_nfd_access (rtp_pkptr, "timestamp", &retContextStatePtr->headerInfo.rtp_timestamp);
									op_pk_nfd_access (rtp_pkptr, "ssrc_synch_src", &retContextStatePtr->headerInfo.rtp_ssrc);
									}
								else
									{
									pktFmtError = 1;
									if (VERBOSE_ERR)
										printf ("Decompressor %d: ERROR - expected RTP header following COMPRESSED_UDP header not found.\n", own_objid);
									}
								
								/* Update the context state information. */
								retContextStatePtr->headerInfo.ip_ident = 
									retContextStatePtr->headerInfo.ip_ident + retContextStatePtr->fieldDeltas.delta_ip_id;
								retContextStatePtr->link_seq = rcvd_link_seq;
								retContextStatePtr->last_packet = retContextStatePtr->headerInfo.rtp_marker;
				
								/* Done updating all the state information. */
				
								}	/* End of "if (fmt_name == "compressed_udp")" */
				
							/* By this time, the RTP packet should have been created.
							   Now need to encapsulate with UDP and IP, given the updated context state info. */
				
							udp_pkptr = op_pk_create_fmt ("udp_v2_pkt");
							op_pk_nfd_set (udp_pkptr, "src_port", retContextStatePtr->headerInfo.udp_src_port);
							op_pk_nfd_set (udp_pkptr, "dest_port", retContextStatePtr->headerInfo.udp_dest_port);
							op_pk_nfd_set (udp_pkptr, "checksum", retContextStatePtr->headerInfo.udp_checksum);
							op_pk_nfd_set (udp_pkptr, "data", rtp_pkptr);
				
							/* UDP length should be determined using IP length from link layer. Since there is 
							   no link layer here, I will determine the length by looking at the size of the 
							   UDP packet and fill in the field thereafter. */
							retContextStatePtr->headerInfo.udp_length = op_pk_total_size_get (udp_pkptr);
							op_pk_nfd_set (udp_pkptr, "length", retContextStatePtr->headerInfo.udp_length);
							
							ip_pkptr = op_pk_create_fmt ("ip_v4_pkt");
				
							op_pk_nfd_set (ip_pkptr, "version", retContextStatePtr->headerInfo.ip_version); 
							op_pk_nfd_set (ip_pkptr, "ihl", retContextStatePtr->headerInfo.ip_ihl); 
							op_pk_nfd_set (ip_pkptr, "tos", retContextStatePtr->headerInfo.ip_tos); 
							op_pk_nfd_set (ip_pkptr, "ident", retContextStatePtr->headerInfo.ip_ident); 
							op_pk_nfd_set (ip_pkptr, "flags", retContextStatePtr->headerInfo.ip_flags); 
							op_pk_nfd_set (ip_pkptr, "frag_offset", retContextStatePtr->headerInfo.ip_frag_offset); 
							op_pk_nfd_set (ip_pkptr, "ttl", retContextStatePtr->headerInfo.ip_ttl); 
							op_pk_nfd_set (ip_pkptr, "protocol", retContextStatePtr->headerInfo.ip_protocol); 
							op_pk_nfd_set (ip_pkptr, "src_addr", retContextStatePtr->headerInfo.ip_src_addr); 
							op_pk_nfd_set (ip_pkptr, "dest_addr", retContextStatePtr->headerInfo.ip_dest_addr); 
							op_pk_nfd_set (ip_pkptr, "data", udp_pkptr);
				
							/* IP length and checksum should be determined from link layer. Since there is 
							   no link layer here, I will determine the length by looking at the size of the 
							   IP packet and fill in the field thereafter. IP checksum is set to zero and ignored. */
							retContextStatePtr->headerInfo.ip_length = op_pk_total_size_get (ip_pkptr);
							op_pk_nfd_set (ip_pkptr, "length", retContextStatePtr->headerInfo.ip_length); 
							retContextStatePtr->headerInfo.ip_header_checksum = 0;
							op_pk_nfd_set (ip_pkptr, "header_checksum", retContextStatePtr->headerInfo.ip_header_checksum);
							
							/* Compute total size of packet bytes 					*/
							pk_size = op_pk_total_size_get (ip_pkptr);
							byte_load = (pk_size / 8.0);
				
							/* Calculate Sent Traffic statistics.					*/
							op_stat_write (sent_decomp_packet_handle, 1.0);
							op_stat_write (sent_decomp_byte_handle, byte_load);
							
							/* Send off packet onto IP network. */
							op_pk_send (ip_pkptr, UNCOMP_OUT_STRM);
				
							}	/* End of "if (droppedPacket)" */
				
						/* Remove this context state from the context state list if the
						last packet has been sent. */
						if (retContextStatePtr->last_packet)
							{
							decompContextStateUpdating = 1;
				
						  	if (VERBOSE_0)
								printf ("Decompressor %d: Removing CID %d (SSRC %d) from Context State Table... ",
								own_objid, retContextStatePtr->context_id, retContextStatePtr->headerInfo.rtp_ssrc);
							
							op_prg_list_remove (contextStateRcvList, foundIndex);
				
							printf ("DONE.\n");
				
							if (op_prg_list_size (contextStateRcvList) == 0)
								{
								if (VERBOSE_0)
									printf ("Decompressor %d: That was the last element of contextStateRcvList.\n", own_objid);
								}
							decompContextStateUpdating = 0;
							}
				
						}	/* End of "else if (found == FOUND)" */
					
					}
				
				/***************************** Uncompressed. **************************************/
				else if (!((strcmp (recv_fmt_name, "crtp_main_hdr") == 0) || (strcmp (recv_fmt_name, "cudp_main_hdr") == 0) 
					|| (strcmp (recv_fmt_name, "context_state_8") == 0) || (strcmp (recv_fmt_name, "context_state_16") == 0)))
					{
				
					strcpy (fmt_name, recv_fmt_name);
					
					if (strcmp (fmt_name, "ip_v4_pkt") == 0)
						{
						ip_pkptr = orig_pkptr;
				
						tempIpLength = op_pk_total_size_get (ip_pkptr);
						
						op_pk_nfd_access (ip_pkptr, "version", &newPktFields.ip_version); 
						op_pk_nfd_access (ip_pkptr, "ihl", &newPktFields.ip_ihl); 
						op_pk_nfd_access (ip_pkptr, "tos", &newPktFields.ip_tos); 
						op_pk_nfd_access (ip_pkptr, "length", &newPktFields.ip_length);
						op_pk_nfd_access (ip_pkptr, "ident", &newPktFields.ip_ident); 
						op_pk_nfd_access (ip_pkptr, "flags", &newPktFields.ip_flags); 
						op_pk_nfd_access (ip_pkptr, "frag_offset", &newPktFields.ip_frag_offset); 
						op_pk_nfd_access (ip_pkptr, "ttl", &newPktFields.ip_ttl); 
						op_pk_nfd_access (ip_pkptr, "protocol", &newPktFields.ip_protocol); 
						op_pk_nfd_access (ip_pkptr, "header_checksum", &newPktFields.ip_header_checksum);
						op_pk_nfd_access (ip_pkptr, "src_addr", &newPktFields.ip_src_addr); 
						op_pk_nfd_access (ip_pkptr, "dest_addr", &newPktFields.ip_dest_addr); 
						op_pk_nfd_get (ip_pkptr, "data", &data_pkptr);
				
						if (CID8)
							{
							rcvd_context_id = newPktFields.ip_length;
							}
						else if (CID16)
							{
							rcvd_link_seq = newPktFields.ip_length;
							}
				
						/* Restore true value of IP length. */
						newPktFields.ip_length = tempIpLength;
						
						op_pk_format (data_pkptr, fmt_name);
						}
				
					if (strcmp (fmt_name, "udp_v2_pkt") == 0)
						{
						udp_pkptr = data_pkptr;
				
						tempUdpLength = op_pk_total_size_get (udp_pkptr);
				
						op_pk_nfd_access (udp_pkptr, "src_port", &newPktFields.udp_src_port);
						op_pk_nfd_access (udp_pkptr, "dest_port", &newPktFields.udp_dest_port);
						op_pk_nfd_access (udp_pkptr, "length", &newPktFields.udp_length);
						op_pk_nfd_access (udp_pkptr, "checksum", &newPktFields.udp_checksum);
				
						if (CID8)
							{
							rcvd_link_seq = newPktFields.udp_length;
							}
						else if (CID16)
							{
							rcvd_context_id = newPktFields.udp_length;
							}
				
						/* Restore true value of UDP length. */
						newPktFields.udp_length = tempUdpLength;
						
						op_pk_nfd_get (udp_pkptr, "data", &data_pkptr);
						op_pk_format (data_pkptr, fmt_name);
						}
				
					if (VERBOSE_1)
						printf ("Decompressor %d: Received FULL HEADER for CID %d +++++++++++++++++++++++\n", own_objid, rcvd_context_id);
				
					if (VERBOSE_XXX)
						{
						printf ("Decompressor %d: link sequence = %d.\n", own_objid, rcvd_link_seq);
						printf ("Decompressor %d: newPktFields.ip_tos = %d.\n", own_objid, newPktFields.ip_tos);
						printf ("Decompressor %d: newPktFields.ip_length = %d.\n", own_objid, newPktFields.ip_length);
						printf ("Decompressor %d: newPktFields.ip_ident = %d.\n", own_objid, newPktFields.ip_ident);
						printf ("Decompressor %d: newPktFields.ip_frag_offset = %d.\n", own_objid, newPktFields.ip_frag_offset);
						printf ("Decompressor %d: newPktFields.ip_ttl = %d.\n", own_objid, newPktFields.ip_ttl);
						printf ("Decompressor %d: newPktFields.ip_protocol = %d.\n", own_objid, newPktFields.ip_protocol);
						printf ("Decompressor %d: newPktFields.ip_src_addr = %d.\n", own_objid, newPktFields.ip_src_addr);
						printf ("Decompressor %d: newPktFields.ip_dest_addr = %d.\n", own_objid, newPktFields.ip_dest_addr);
				
						printf ("Decompressor %d: newPktFields.udp_src_port = %d.\n", own_objid, newPktFields.udp_src_port);
						printf ("Decompressor %d: newPktFields.udp_dest_port = %d.\n", own_objid, newPktFields.udp_dest_port);
						printf ("Decompressor %d: newPktFields.udp_length = %d.\n", own_objid, newPktFields.udp_length);
						printf ("Decompressor %d: newPktFields.udp_checksum = %d.\n", own_objid, newPktFields.udp_checksum);
						}
					
					if (strcmp (fmt_name, "rtp_pkt") == 0)
						{
						rtp_pkptr = data_pkptr;
						op_pk_nfd_access (rtp_pkptr, "version", &newPktFields.rtp_version);
						op_pk_nfd_access (rtp_pkptr, "padding", &newPktFields.rtp_padding);
						op_pk_nfd_access (rtp_pkptr, "extension", &newPktFields.rtp_extension);
						op_pk_nfd_access (rtp_pkptr, "csrc_count", &newPktFields.rtp_csrc_count);
						op_pk_nfd_access (rtp_pkptr, "marker", &newPktFields.rtp_marker);
						op_pk_nfd_access (rtp_pkptr, "payload_type", &newPktFields.rtp_payload_type);
						op_pk_nfd_access (rtp_pkptr, "seq_number", &newPktFields.rtp_seq_number);
						op_pk_nfd_access (rtp_pkptr, "timestamp", &newPktFields.rtp_timestamp);
						op_pk_nfd_access (rtp_pkptr, "ssrc_synch_src", &newPktFields.rtp_ssrc);
				
						if (VERBOSE_XXX)
							{
							printf ("Decompressor %d: newPktFields.rtp_version = %d.\n", own_objid, newPktFields.rtp_version);
							printf ("Decompressor %d: newPktFields.rtp_padding = %d.\n", own_objid, newPktFields.rtp_padding);
							printf ("Decompressor %d: newPktFields.rtp_extension = %d.\n", own_objid, newPktFields.rtp_extension);
							printf ("Decompressor %d: newPktFields.rtp_csrc_count = %d.\n", own_objid, newPktFields.rtp_csrc_count);
							printf ("Decompressor %d: newPktFields.rtp_marker = %d.\n", own_objid, newPktFields.rtp_marker);
							printf ("Decompressor %d: newPktFields.rtp_payload_type = %d.\n", own_objid, newPktFields.rtp_payload_type);
							printf ("Decompressor %d: newPktFields.rtp_seq_number = %d.\n", own_objid, newPktFields.rtp_seq_number);
							printf ("Decompressor %d: newPktFields.rtp_timestamp = %d.\n", own_objid, newPktFields.rtp_timestamp);
							printf ("Decompressor %d: newPktFields.rtp_ssrc = %d.\n", own_objid, newPktFields.rtp_ssrc);
							}
						op_pk_nfd_get (rtp_pkptr, "data", &payload_pkptr);
						}
				
					found = NOT_FOUND;
					i = OPC_LISTPOS_HEAD;
					rcvListSize = op_prg_list_size(contextStateRcvList);
					if (rcvListSize > 0)
						{
						i = OPC_LISTPOS_HEAD;
						while ((i < rcvListSize) && (found == NOT_FOUND))
							{
							retContextStatePtr = op_prg_list_access (contextStateRcvList, i);
						
							if (rcvd_context_id == retContextStatePtr->context_id)
								{
								found = FOUND;
								foundIndex = i;
								}
							i++;
							}
						}
					
					if (found == NOT_FOUND)
						{
						/* First packet of new stream. */
						if ((newPktFields.rtp_marker != 1) || (rcvd_link_seq != 0))
							{
							/* Marker should be set if it is the first packet of a new stream. */
							error = 1;
							errorCountDecomp++;
							if (VERBOSE_ERR)
								printf ("Decompressor %d: ERROR - marker not set in packet for first packet.\n", own_objid);
							}
						else
							{
							/* Insert this packet's information as a new context state. */
							tempContextStatePtr = op_prg_mem_alloc (sizeof(CONTEXT_STATE_INFO));
							tempContextStatePtr->headerInfo = newPktFields;
							tempContextStatePtr->fieldDeltas.delta_ip_id = 1;
							tempContextStatePtr->fieldDeltas.delta_rtp_ts = 0;
							tempContextStatePtr->fieldDeltas.delta_rtp_seq = 1;
							tempContextStatePtr->context_id = rcvd_context_id;
							tempContextStatePtr->link_seq = 0;			/* init the link sequence to 0. */
							tempContextStatePtr->last_packet = 0; 		/* last packet not received yet. */
							tempContextStatePtr->invalid = 0;			/* context state is valid by default */
				
							if (VERBOSE_0)
								printf ("Decompressor %d: CID %d (SSRC %d) added to Context State Table.\n", own_objid, rcvd_context_id, newPktFields.rtp_ssrc);
				
							op_prg_list_insert (contextStateRcvList, tempContextStatePtr, OPC_LISTPOS_TAIL);
						
							/* Refill in the length fields of the UDP and IP headers. */
							op_pk_nfd_set (rtp_pkptr, "data", payload_pkptr);
							op_pk_nfd_set (udp_pkptr, "data", rtp_pkptr);
							op_pk_nfd_set (udp_pkptr, "length", tempContextStatePtr->headerInfo.udp_length);
							op_pk_nfd_set (ip_pkptr, "data", udp_pkptr);
							op_pk_nfd_set (ip_pkptr, "length", tempContextStatePtr->headerInfo.ip_length);
				
							/* Compute total size of packet bytes 					*/
							pk_size = op_pk_total_size_get (ip_pkptr);
							byte_load = (pk_size / 8.0);
				
							/* Calculate Sent Traffic statistics.					*/
							op_stat_write (sent_decomp_packet_handle, 1.0);
							op_stat_write (sent_decomp_byte_handle, byte_load);
						
							/* Send packet to network. */
							op_pk_send (ip_pkptr, UNCOMP_OUT_STRM);
				
							if (VERBOSE_X)
							printf ("Decompressor %d: First packet sent out to packet stream %d.\n", own_objid, UNCOMP_OUT_STRM);
							}
						}
				
					else if (found == FOUND)
						{
						/* Session State exists and is list element foundIndex and pointed to by retContextStatePtr. */
						/* Update some elements of the session context. */
						if (retContextStatePtr->invalid > 0)
							{
							if (VERBOSE_X)
								printf ("Decompressor %d: Context state CID %d received full header. Re-validated.\n", own_objid, retContextStatePtr->context_id);
				
							retContextStatePtr->invalid = 0;		/* Invalid context state is valid after FULL HEADER received. */
							}
						retContextStatePtr->headerInfo = newPktFields;
						retContextStatePtr->fieldDeltas.delta_ip_id = 1;
						retContextStatePtr->fieldDeltas.delta_rtp_ts = 0;
						retContextStatePtr->fieldDeltas.delta_rtp_seq = 1;
						retContextStatePtr->last_packet = newPktFields.rtp_marker;
						retContextStatePtr->link_seq = rcvd_link_seq;
						
						/* Refill in the length fields of the UDP and IP headers. */
						op_pk_nfd_set (rtp_pkptr, "data", payload_pkptr);
						op_pk_nfd_set (udp_pkptr, "data", rtp_pkptr);
						op_pk_nfd_set (udp_pkptr, "length", retContextStatePtr->headerInfo.udp_length);
						op_pk_nfd_set (ip_pkptr, "data", udp_pkptr);
						op_pk_nfd_set (ip_pkptr, "length", retContextStatePtr->headerInfo.ip_length);
				
						/* Compute total size of packet bytes 					*/
						pk_size = op_pk_total_size_get (ip_pkptr);
						byte_load = (pk_size / 8.0);
				
						/* Calculate Sent Traffic statistics.					*/
						op_stat_write (sent_decomp_packet_handle, 1.0);
						op_stat_write (sent_decomp_byte_handle, byte_load);
						
						/* Send packet to network. 								*/
						op_pk_send (ip_pkptr, UNCOMP_OUT_STRM);
				
						/* Remove this context state from the context state list if the last packet has been sent. */
						if (retContextStatePtr->last_packet)
							{
							decompContextStateUpdating = 1;
				
							if (VERBOSE_0)
								printf ("Decompressor %d: Removing CID %d (SSRC %d) from Context State Table... ",
									own_objid, retContextStatePtr->context_id, retContextStatePtr->headerInfo.rtp_ssrc);
							
							op_prg_list_remove (contextStateRcvList, foundIndex);
				
							printf ("DONE.\n");
				
							if (op_prg_list_size (contextStateRcvList) == 0)
								{
								if (VERBOSE_X)
									printf ("Decompressor %d: That was the last element of contextStateRcvList.\n", own_objid);
								}
				
							decompContextStateUpdating = 0;
							}
						}
					}
				}

				FSM_PROFILE_SECTION_OUT ("cRTP [decompressor enter execs]", state3_enter_exec)

			/** state (decompressor) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "decompressor", "cRTP [decompressor exit execs]")
				FSM_PROFILE_SECTION_IN ("cRTP [decompressor exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cRTP [decompressor exit execs]", state3_exit_exec)


			/** state (decompressor) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "decompressor", "wait")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,cRTP)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
cRTP_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (cRTP_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (cRTP)",
			sizeof (cRTP_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((cRTP_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
cRTP_diag (void)
	{
	/* No Diagnostic Block */
	}




void
cRTP_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (cRTP_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cRTP_svar function. */
#undef contextStateXmtList
#undef contextStateRcvList
#undef errorCountComp
#undef errorCountDecomp
#undef totalDroppedPackets
#undef comp_ici_ptr
#undef rcvd_comp_packet_handle
#undef rcvd_comp_byte_handle
#undef rcvd_decomp_packet_handle
#undef rcvd_decomp_byte_handle
#undef sent_comp_packet_handle
#undef sent_comp_byte_handle
#undef sent_decomp_packet_handle
#undef sent_decomp_byte_handle
#undef compContextStateUpdating
#undef decompContextStateUpdating
#undef recv_fmt_name
#undef fmt_name
#undef decomp_ici_ptr
#undef num_dropped_packets
#undef own_objid
#undef packet_dropped_handle
#undef sent_context_state_handle
#undef rcvd_context_state_handle



void
cRTP_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	cRTP_state		*prs_ptr;

	FIN (cRTP_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cRTP_state *)gen_ptr;

	if (strcmp ("contextStateXmtList" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->contextStateXmtList);
		FOUT
		}
	if (strcmp ("contextStateRcvList" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->contextStateRcvList);
		FOUT
		}
	if (strcmp ("errorCountComp" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->errorCountComp);
		FOUT
		}
	if (strcmp ("errorCountDecomp" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->errorCountDecomp);
		FOUT
		}
	if (strcmp ("totalDroppedPackets" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->totalDroppedPackets);
		FOUT
		}
	if (strcmp ("comp_ici_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->comp_ici_ptr);
		FOUT
		}
	if (strcmp ("rcvd_comp_packet_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rcvd_comp_packet_handle);
		FOUT
		}
	if (strcmp ("rcvd_comp_byte_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rcvd_comp_byte_handle);
		FOUT
		}
	if (strcmp ("rcvd_decomp_packet_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rcvd_decomp_packet_handle);
		FOUT
		}
	if (strcmp ("rcvd_decomp_byte_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rcvd_decomp_byte_handle);
		FOUT
		}
	if (strcmp ("sent_comp_packet_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->sent_comp_packet_handle);
		FOUT
		}
	if (strcmp ("sent_comp_byte_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->sent_comp_byte_handle);
		FOUT
		}
	if (strcmp ("sent_decomp_packet_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->sent_decomp_packet_handle);
		FOUT
		}
	if (strcmp ("sent_decomp_byte_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->sent_decomp_byte_handle);
		FOUT
		}
	if (strcmp ("compContextStateUpdating" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->compContextStateUpdating);
		FOUT
		}
	if (strcmp ("decompContextStateUpdating" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->decompContextStateUpdating);
		FOUT
		}
	if (strcmp ("recv_fmt_name" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->recv_fmt_name);
		FOUT
		}
	if (strcmp ("fmt_name" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->fmt_name);
		FOUT
		}
	if (strcmp ("decomp_ici_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->decomp_ici_ptr);
		FOUT
		}
	if (strcmp ("num_dropped_packets" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->num_dropped_packets);
		FOUT
		}
	if (strcmp ("own_objid" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->own_objid);
		FOUT
		}
	if (strcmp ("packet_dropped_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->packet_dropped_handle);
		FOUT
		}
	if (strcmp ("sent_context_state_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->sent_context_state_handle);
		FOUT
		}
	if (strcmp ("rcvd_context_state_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rcvd_context_state_handle);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

